#ifndef __TOGGLE_H
#define __TOGGLE_H

#include <stdio.h>
#include "propeller.h"

#define dprintf printf

/*
 * toggle interface definitions
 */

/* probably don't need a stack, but provide a small one just in case */
#define STACK_SIZE 16

typedef struct toggle_mailbox {
    unsigned int wait_time; /* time to sleep between toggles */
    unsigned int togglecount;
} Mailbox_t;

typedef struct par {
    unsigned stack[STACK_SIZE];
    Mailbox_t m;
} Par_t;

/*
 * handle xmm cog c load code
 */
#define extern_driver(id) extern uint32_t _load_start_##id[], _load_stop_##id[]
#define cog_driver(id) _load_start_##id
#define cog_size(id)   _load_stop_##id - _load_start_##id

#if defined(__PROPELLER_XMM__) || defined(__PROPELLER_XMMC__)

int load_cog(uint32_t *pasm, int size, volatile void *parm)
{
    int cog;
    uint32_t pasmbuff[size];
    dprintf("pasmbuff address %x size %d\n", pasmbuff, size);
    copy_from_xmm(pasmbuff, pasm, size); // library function
    cog = cognew(pasmbuff, parm);
    dprintf("load_cog started cog %d\n", cog);
    return cog;
}

#define loadcog(id, size, parm) load_cog((id),(size),(parm))

#else

#define loadcog(id, size, parm) cognew((id),(parm))

#endif


#endif